// Demo1.java
//
// simple program to test
//		Audio.jar
//		SoundBite.dll
//




import Audio.*;		// Audio, SampleRate

import java.io.*;
import java.awt.*;


public class Demo1 {
	public static void main(String[] args) {

		System.out.println("");

		try {
			SoundBite	s = new SoundBite("chimes.wav");
			s.recordWaitForGet();

			System.out.println("\tloaded chimes.wav");

			System.out.println("\tstarting playing");
			{
				s.playStart();
				s.playWaitFor();
			}
			System.out.println("\tplaying done");

			s.dispose();
		} catch (SoundBiteException e) {
			e.printStackTrace();
			System.err.println("Demo1.main(): exception: " + e.getMessage());
			System.exit(-1);
		}

		System.out.println("");

		try {
			Audio.SoundBite	s = null;
			int	numseconds = 5;

			s = new Audio.SoundBite(true, true, Audio.SampleRate.R_11025, numseconds * Audio.SampleRate.R_11025.toInt());

			System.out.println("\tstarting recording");
			{
				s.recordStart();
				// s.recordWaitFor();
				// or
				s.recordWaitForGet();
			}
			System.out.println("\trecording done");

			System.out.println("");

			System.out.println("\tstarting playing");
			{
				s.playStart();
				s.playWaitFor();
			}
			System.out.println("\tplaying done");

			s.dispose();
		} catch (Audio.SoundBiteException e) {
			e.printStackTrace();
			System.err.println("Demo1.main(): exception: " + e.getMessage());
			System.exit(-1);
		}

		System.out.println("");

		try {
			// is_16its = true
			// is_stereo = true
			// samplespersec = 11025
			//
			int	numseconds = 5;
			SoundBite	s = new SoundBite(true, true, Audio.SampleRate.R_11025, numseconds * Audio.SampleRate.R_11025.toInt());

			System.out.println("\tgenerate a 500 Hz tone for " + numseconds + " seconds");
			System.out.println("\tby setting left[], right[], numsamples");
			{
				float	freq = (float)500.0;
				int		maxnumsamples = s.getMaxNumSamples();
				float	factor = (float)(2 * Math.PI * freq)/s.getSamplesPerSec();
				int		samplerange = s.getSampleRange();
				int		midsamplerange = s.getMidSampleRange();


				// set left[], right[]

				for (int i = 0; i < maxnumsamples; i++) {
					// reduce from full scale sine wave to 0.25 .. else too loud

					s.left[i] = (short)(midsamplerange + 0.25 * (0.5 * samplerange * Math.sin(i * factor)));
					s.right[i] = s.left[i];
				}

				// set "numsamples"
				s.setNumSamples(maxnumsamples);
			}
			System.out.println("\tset left[], right[], numsamples");

			System.out.println("");

			System.out.println("\tstarting playing");
			{
				s.playStart();
				s.playWaitFor();
			}
			System.out.println("\tplaying done");

			System.out.println("");

			System.out.println("\tsaving to file output.wav");
			s.save("output.wav");
			System.out.println("\tdone saving to file");

			s.dispose();
		} catch (SoundBiteException e) {
			e.printStackTrace();
			System.err.println("Demo1.main(): exception: " + e.getMessage());
			System.exit(-1);
		}
	}
}

